package ru.skipy.tests.ui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * DebugAndDoubleBufferingTest
 *
 * @author Eugene Matyushkin aka Skipy
 * @version $Id: $
 * @since 13.11.2010
 */
public class DebugAndDoubleBufferingTest extends JFrame {

    DebugAndDoubleBufferingTest() {
        super("DebugGraphics and double buffering");
        final JPanel cp = new JPanel(new BorderLayout(5, 5));
        cp.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
        final JButton btn = new JButton("Close") {
            @Override
            protected void paintComponent(Graphics g) {
                System.out.println("Painting JButton at " + System.currentTimeMillis());
                super.paintComponent(g);
            }
        };
        btn.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });
        cp.add(btn, BorderLayout.CENTER);

        JPanel optPanel = new JPanel(new BorderLayout(5, 5));
        final JCheckBox chkDebug = new JCheckBox("Debug graphics", false);
        final JCheckBox chkDB = new JCheckBox("Use DoubleBuffering", true);
        optPanel.add(chkDebug, BorderLayout.WEST);
        optPanel.add(chkDB, BorderLayout.EAST);
        cp.add(optPanel, BorderLayout.SOUTH);

        chkDebug.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                cp.setDebugGraphicsOptions(chkDebug.isSelected() ?
                        DebugGraphics.FLASH_OPTION : DebugGraphics.NONE_OPTION);
            }
        });

        chkDB.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                RepaintManager.currentManager(cp).setDoubleBufferingEnabled(chkDB.isSelected());
            }
        });

        setContentPane(cp);
        setSize(400, 300);
        setLocationRelativeTo(null);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
    }

    public static void main(String[] args) {
        DebugGraphics.setFlashCount(1);
        DebugGraphics.setFlashTime(20);
        DebugGraphics.setFlashColor(Color.red);
        new DebugAndDoubleBufferingTest().setVisible(true);
    }

}
