package ru.skipy.tests.ui;

import ru.skipy.tests.ui.component.SimpleComponent;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * SimpleComponentTest - simple component demo
 *
 * @author Eugene Matyushkin aka Skipy
 * @version $Id: $
 * @since 21.10.2010
 */
public class SimpleComponentTest extends JFrame {

    public SimpleComponentTest(boolean callSuper, boolean isOpaque, SimpleComponent.Clip clip) {
        super("Simple component test");
        JPanel cp = new JPanel(new BorderLayout());
        cp.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5),
                BorderFactory.createLineBorder(Color.black)));
        setContentPane(cp);
        cp.add(new SimpleComponent(callSuper, isOpaque, clip), BorderLayout.CENTER);
        JButton btn = new JButton("Close");
        btn.setOpaque(false);
        btn.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });
        cp.add(btn, BorderLayout.SOUTH);
        cp.setBackground(Color.green);
        setSize(500, 400);
        setLocationRelativeTo(null);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
    }

    public static void main(String[] args) {
        String callSuper = System.getProperty("callSuper");
        String isOpaque = System.getProperty("isOpaque");
        String clipMode = System.getProperty("clipMode");
        SimpleComponent.Clip clip = null;
        if (clipMode != null && clipMode.length() > 0) {
            try {
                clip = SimpleComponent.Clip.valueOf(clipMode);
            } catch (IllegalArgumentException ex) {
                System.err.println("Clip mode doesn't exist: " + clipMode);
            }
        }
        new SimpleComponentTest(Boolean.parseBoolean(callSuper),
                Boolean.parseBoolean(isOpaque), clip).setVisible(true);
    }
}
