package ru.skipy.tests.ui.component.graph;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.Point2D;

/**
 * FunctionGraphPanelGP - graph panel implementation using direct point-to-point drawing
 *
 * @author Eugene Matyushkin aka Skipy
 * @version $Id: $
 * @since 08.10.2010
 */
public class FunctionGraphPanelLine extends AbstractFunctionGraphPanel {

    public FunctionGraphPanelLine(GraphDescriptor descriptor, Color c) {
        super(descriptor, c);
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        if (function == null) {
            return;
        }
        int w = getWidth();
        int h = getHeight();
        if (w <= 2 * GAP || h <= 2 * GAP)
            return;
        Graphics2D g2d = (Graphics2D) g;
        int ew = w - 2 * GAP;
        int eh = h - 2 * GAP;
        double stepX = (maxX - minX) / ew;
        double stepY = (maxY - minY) / eh;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2d.setPaint(Color.darkGray);
        g2d.drawLine(GAP, (int) (GAP + maxY / stepY), GAP + ew, (int) (GAP + maxY / stepY));
        g2d.drawLine((int) (GAP - minX / stepX), GAP, (int) (GAP - minX / stepX), GAP + eh);
        g2d.setPaint(c);
        Point2D start = getGraphPoint(minX, stepX, stepY);
        int x0 = GAP;
        int y0 = (int) (GAP + eh - start.getY());
        for (int i = 1; i <= ew; i++) {
            Point2D p = getGraphPoint(i * stepX + minX, stepX, stepY);
            int x1 = GAP + i;
            int y1 = (int) (GAP + eh - p.getY());
            g2d.drawLine(x0, y0, x1, y1);
            x0 = x1;
            y0 = y1;
        }
    }
}
