package ru.skipy.tests.ui.component.graph;

/**
 * Abstract function graph descriptor
 *
 * @author Eugene Matyushkin aka Skipy
 * @version $Id: $
 * @since 08.10.2010
 */
public abstract class GraphDescriptor implements Function {

    /**
     * Function args/values area
     */
    public double minX;
    public double minY;
    public double maxX;
    public double maxY;

    public GraphDescriptor(double minX, double minY, double maxX, double maxY) {
        this.minX = minX;
        this.minY = minY;
        this.maxX = maxX;
        this.maxY = maxY;
    }

    public double getMinX() {
        return minX;
    }

    public double getMinY() {
        return minY;
    }

    public double getMaxX() {
        return maxX;
    }

    public double getMaxY() {
        return maxY;
    }

    public abstract String getDescription();

    @Override
    public String toString() {
        return getDescription();
    }
}